#!/usr/bin/env octave


function ys = euler(f,t,y,h)
  t0=t(1); tn=t(2);
  tx=t0; ys=zeros(ceil((tn-t0)/h),length(y));
  ys(1,:)=y; i=1;
  while (tx<tn)
    i = i+1; tx=tx+h;
    ys(i,:) = ys(i-1,:)' + (h * feval(f,tx,ys(i-1,:)));
  endwhile
endfunction

## Hodgkin-Huxley model driver for Octave

hh_defs = "hh-substrate.m";
##hh_defs = "hh-superstrate.m";

autoload ("hodgkin_huxley", hh_defs );
autoload ("hodgkin_huxley_init", hh_defs );

y0 = hodgkin_huxley_init(-65)

#t = linspace(0,100,1000);
#lsode_options("initial step size",0.001);
#y = lsode ("hodgkin_huxley", y0, t);

#t = [0,100];
#P = odeset ('InitialStep', 0.0001 );
#[t, y] = odesx (@hodgkin_huxley, t, y0, P);

t = [0,10];
y = euler (@hodgkin_huxley, t, y0, 0.001)

save "-ascii" "hodgkin_huxley.dat" y;
